
//+------------------------------------------------------------------+
//|                                                    4HR-GL EA.mq4 |
//|                                                      Rory Kruger |
//|                                             roryk@vodamail.co.za |
//+------------------------------------------------------------------+
#property copyright "Rory Kruger"
#property link      "roryk@vodamail.co.za"

//=================================================================//
//--------------------------- EXTERNALS ---------------------------//
//=================================================================//
extern string  Adjustable_Settings     = "-----------------****************-----------------";
                        
extern string  Trade_Details           = "-================================================-";
extern double  LotSize                 =    0.1;
extern double  TrailingStop            =     20;

extern string  Indicator_Settings      = "-================================================-";
extern int     RSI                     =     21; 

extern string  Trade_Times             = "-================================================-";        
extern int     START_HOUR              =      4;
extern int     END_HOUR                =     20;

extern string  Entry_Criteria          = "-================================================-";
extern int     EMA_DIST                =     80;   // Distance from 89 EMA to enter a trade order 
extern int     ENTRY_DIST              =     10;   // Distance from high or low of candle to enter a trade order

extern string  Magic_Number            = "-================================================-";
extern int     Magic                   = 709090;   // Magic number

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {

//===================================================================//
//------------------------ DECLARED VARIABLES -----------------------//
//===================================================================//

double sema;                // Short EMA (89EMA)
double lema;                // Long EMA  (200EMA)
double rsi;                 // RSI (21 as default)
double mpl ;                // MPI-TL custom indicator

int cct,ticket;             // cct = close current trade variable , ticket = OrderSend variable 

double stoploss;            // Stop Loss 

double result;              // Result of SHORT position Take Profit calculation(see CALCULATIONS)



//====================================================================//
//-------------------- INDICATORS AND VARIABLES ARE :-----------------//
//====================================================================//  
   
   sema     = iMA(NULL,0,89,0,MODE_EMA,PRICE_CLOSE,0);    // 89 EMA
   lema     = iMA(NULL,0,200,0,MODE_EMA,PRICE_CLOSE,0);   // 200 EMA
   
   mpl      = iCustom(NULL,0,"MPi-TL",5,0.618,0,0);       // Custom MPi-TL indicator
   
   rsi      = iRSI(Symbol(),0,RSI,PRICE_CLOSE,0);         // RSI
   
   int total       = OrdersTotal();                       // Definition of declared variables
   
   double entry    = OrderOpenPrice();                    // Definition of declared variables
   
                            
//===================================================================//         
//-------------------------- CALCULATIONS ---------------------------//
//===================================================================//
        
         //-----------------------------------------------------------------------------------------//
         // LONG  position Stoploss calculation -- Lowest  low  of last week and current week range //
         //-----------------------------------------------------------------------------------------// 

double sll    = iLow(Symbol(),PERIOD_W1,iLowest(Symbol(),PERIOD_W1,MODE_LOW,2,1));        
    Print(" weekly low = " + sll);

        //-----------------------------------------------------------------------------------------//
        // SHORT position Stoploss calculation -- Highest high of last week and current week range //
        //-----------------------------------------------------------------------------------------//
        
double sls    = iHigh(Symbol(),PERIOD_W1,iHighest(Symbol(),PERIOD_W1,MODE_HIGH,2,1));  
 Print ("Weekly High =" +sls);
                       
        //---------------------------------------//               
        // LONG Position TAKE PROFIT calculation //
        //---------------------------------------//                
                        
double tpl    = (entry-sll);           
double tpl2   =  tpl*0.618;
double ftpl   = entry+tpl2;            // ftpl = Final Take Profit figure for LONG positions//


  
       //----------------------------------------//              
       // Short position TAKE PROFIT calculation //     
       //----------------------------------------//

double tps    = (entry-sls);           // RESULT to be used in SHORT position Take profit calculation //
double tps2   = tps*0.618;
double ftps   = entry-tps2;            // ftps = Final Take Profit value for SHORT positions //


      //=========================================//
      //-- WHICH 4HR CANDLE TO ENTER THE TRADE --//
      //=========================================//

double fhh    = High[iHighest(NULL,PERIOD_H4,MODE_HIGH,1,1)];     // Four Hour candle highest high of last 2 candles
double fhl    = Low[iLowest(NULL,PERIOD_H4,MODE_LOW,1,1)];        // Four hour candle lowest low of last 2 candles
      
      //==================// 
      //-- ENTRY POINTS --//
      //==================//
                     
  int EMA_DIST = 80;
  double b = EMA_DIST*Point;    // Must enter trades 80 pips from an EMA //
  double c = sema+b;
  double d = sema-b;
  
  int ENTRY_DIST = 10;
  double e = ENTRY_DIST*Point;  // Must enter trade 10 pips higher than highest high of 4HR candle //
  double f = sema+e;
  double g = sema-e;
  

//====================================================================//  
//-------------------------- HISTORY CHECK ---------------------------//
//====================================================================//
   
   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
   
//==================================================================// 
//------------------------ HOURS TO TRADE --------------------------//
//==================================================================//

bool TRADETIME=false; 

if(Hour()>=START_HOUR || Hour()<END_HOUR)  // Only trade during these hours,  selected externally
TRADETIME=true; 

//==================================================================//
//---------------------- PRE TRADE CRITERIA ------------------------//
//==================================================================//

if(Volume[0]==1 && TRADETIME==true)     // Open trade only on NEW candle and during selected trade hours //
      {
      if(total<1)    // No currently open orders //
        {
         if(AccountFreeMargin()<(1000*LotSize))
             {
              Print("Not enough money to trade , free margin = ",AccountFreeMargin());
           return(0);
           }

//==================================================================//           
//------------------- CRITERIA TO OPEN A TRADE ---------------------//
//==================================================================//
                               
                     //--- BUY CRITERIA ---//

if(Close[2]>mpl && Close[1]>mpl && rsi>50 && Bid>=f && c<Bid || d>Bid) 
{
ticket = OrderSend(Symbol(),OP_BUY,LotSize,Ask,3,sll,ftpl,"4HR-GL",Magic,0,Green);
if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
           }
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
         }
         


                     //--- SELL CRITERIA ---//

if(Close[2]<mpl && Close[1]<mpl && rsi<50 && Bid<=g && (d>Bid || c<Bid))  
{
ticket = OrderSend(Symbol(),OP_SELL,LotSize,Bid,3,sls,ftps,"4HR-GL",Magic,0,Red);
if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
           }
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
         }         

return(0);
}

//==================================================================//
//---------CLOSE ORDER CRITERIA AND TRAILINGSTOP CRITERIA ----------//
//==================================================================//

for(cct=0;cct<total;cct++)
           {
          OrderSelect(cct,SELECT_BY_POS,MODE_TRADES);
             
             if(OrderType()<=OP_SELL && OrderSymbol()==Symbol())
               {
               if(OrderType()==OP_BUY)
                  {
                   if(Close[1]<mpl || rsi<50)
                    {
                     OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet);
                     return(0);
                     }
                     
             if(TrailingStop>0)
                {
                 if(Bid-OrderOpenPrice()> Point*TrailingStop)
                    {
                    if(OrderStopLoss()<Bid-Point*TrailingStop)
                       {
                        OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                        return(0);
                       }
                    }
                 }
              }
              else
              {
              if(Close[1]>mpl || rsi>50)
                 {
                  OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
                  return(0); // exit
                 }
              if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
              }
             }
            }
           }
          }
         }
        }      
         return(0);
        } 

//+------------------------------------------------------------------+